// ////////////////////////////////////////////////////
//
// StdView.h : interface of the CStdView class
// Based on class COGLView : public CView
// Inspect COGLView for standard OpenGL initialization
//
////////////////////////////////////////////////////////
#include "oglview.h"

class CStdView : public COGLView
{
protected: 
	CStdView();
	DECLARE_DYNCREATE(CStdView)

// Attributes
public:
	// image object to store bitmaps for texture
	CGLImage m_theImage;
	// which shape
	int m_theShape;

	// hide back sides
	BOOL m_hideBack;

	// material index
	int m_Material;

	// moving around
	CPoint m_PLast,m_PLastZ;
	GLfloat m_Vz,m_Vx,m_Vy;
	GLfloat m_EyeZ,m_EyeY,m_EyeX;
	// increments on move
	GLfloat	m_dvy;
	GLfloat m_dvx;
	BOOL m_bHasStopped;

// Operations
public:
	CStdDoc* GetDocument();
	virtual void DrawScene();
	virtual void InitializeRContext();
	void SetHomePos();
	BOOL LoadTexture(CString name);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CStdView)
	//}}AFX_VIRTUAL

// Implementation
public:
	void DrawTexBox(GLfloat dx,GLfloat dy,GLfloat dz);
	void DrawSphere();
	void DrawCylinder();
	void DrawDisk();
	void DrawPolygon();
	void DrawBezier();
	virtual ~CStdView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CStdView)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnViewHome();
	afx_msg void OnShapeBox();
	afx_msg void OnShapeCylinder();
	afx_msg void OnShapeDisk();
	afx_msg void OnShapePolygon();
	afx_msg void OnShapeSphere();
	afx_msg void OnBitmapLoad();
	afx_msg void OnUpdateShapeBox(CCmdUI* pCmdUI);
	afx_msg void OnUpdateShapeCylinder(CCmdUI* pCmdUI);
	afx_msg void OnUpdateShapeDisk(CCmdUI* pCmdUI);
	afx_msg void OnUpdateShapePolygon(CCmdUI* pCmdUI);
	afx_msg void OnUpdateShapeSphere(CCmdUI* pCmdUI);
	afx_msg void OnViewHideBack();
	afx_msg void OnUpdateViewHideBack(CCmdUI* pCmdUI);
	afx_msg void OnShapeBezier();
	afx_msg void OnUpdateShapeBezier(CCmdUI* pCmdUI);
	afx_msg void OnViewBasicMat();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in StdView.cpp
inline CStdDoc* CStdView::GetDocument()
   { return (CStdDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
